diff -up orinoco-0.15rc2/orinoco_pci.c orinoco-0.15rc2-new/orinoco_pci.c
--- orinoco-0.15rc2/orinoco_pci.c	2004-07-28 08:06:45.000000000 +0200
+++ orinoco-0.15rc2-new/orinoco_pci.c	2005-06-19 17:13:07.000000000 +0200
@@ -327,7 +327,7 @@ static int orinoco_pci_suspend(struct pc
 	
 	orinoco_unlock(priv, &flags);
 
-	pci_save_state(pdev, card->pci_state);
+	pci_save_state(pdev);
 	pci_set_power_state(pdev, 3);
 
 	return 0;
@@ -344,7 +344,7 @@ static int orinoco_pci_resume(struct pci
 	printk(KERN_DEBUG "%s: Orinoco-PCI waking up\n", dev->name);
 
 	pci_set_power_state(pdev, 0);
-	pci_restore_state(pdev, card->pci_state);
+	pci_restore_state(pdev);
 
 	err = orinoco_reinit_firmware(dev);
 	if (err) {
diff -up orinoco-0.15rc2/spectrum_cs.c orinoco-0.15rc2-new/spectrum_cs.c
--- orinoco-0.15rc2/spectrum_cs.c	2004-07-28 08:06:45.000000000 +0200
+++ orinoco-0.15rc2-new/spectrum_cs.c	2005-06-19 18:06:39.000000000 +0200
@@ -579,12 +579,13 @@ static int
 spectrum_dl_firmware(hermes_t *hw, dev_link_t *link)
 {
 	int ret;
+	client_handle_t handle = link->handle;
 
 #ifndef SPECTRUM_FW_INCLUDED
 	const struct firmware *fw_entry;
 
 	if (request_firmware(&fw_entry, primary_fw_name,
-			     spectrum_cs_device) == 0) {
+			     &handle_to_dev(handle)) == 0) {
 		primsym = fw_entry->data;
 	} else {
 		printk(KERN_ERR PFX "Cannot find firmware: %s\n",
@@ -593,7 +594,7 @@ spectrum_dl_firmware(hermes_t *hw, dev_l
 	}
 
 	if (request_firmware(&fw_entry, secondary_fw_name,
-			     spectrum_cs_device) == 0) {
+			     &handle_to_dev(handle)) == 0) {
 		secsym = fw_entry->data;
 	} else {
 		printk(KERN_ERR PFX "Cannot find firmware: %s\n",
